diff --git a/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/TraktLogger.cs b/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/TraktLogger.cs
index fb5cb3e..282ef6a 100644
--- a/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/TraktLogger.cs
+++ b/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/TraktLogger.cs
@@ -1,24 +1,79 @@
 ﻿using System;
-using MediaPortal.Common;
-using MediaPortal.Common.Logging;
+using System.IO;
+using System.Linq;
+using System.Net;
+using System.Threading;
 using MediaPortal.Extensions.OnlineLibraries.Libraries.Trakt.DataStructures;
+using MediaPortal.Extensions.OnlineLibraries.Libraries.Trakt.Extension;
 
 namespace MediaPortal.Extensions.OnlineLibraries.Libraries.Trakt
 {
-  static class TraktLogger
+  public static class TraktLogger
   {
+    private static Object lockObject = new object();
+    //private static string latencyFilename = Config.GetFile(Config.Dir.Log, "TraktPlugin-Latencies.csv");
+    //private static string logFilename = Config.GetFile(Config.Dir.Log, "TraktPlugin.log");
+    //private static string logFilePattern = Config.GetFile(Config.Dir.Log, "TraktPlugin.{0}.log");
+
+    internal delegate void OnLogReceivedDelegate(string message, bool error);
+
+    internal static event OnLogReceivedDelegate OnLogReceived;
+
     static TraktLogger()
     {
+      // default logging before we load settings
+      TraktSettings.LogLevel = 2;
+
+      #region Log Rollover
+
+      // get max number of log files to create
+      int maxLogFiles = 5;
+
+      // delete legacy backup
+      //DeleteFile(Config.GetFile(Config.Dir.Log, "TraktPlugin.bak"));
+
+      //// delete oldest log file if it exists
+      //string newLogFile = string.Empty;
+      //string oldLogFile = string.Format(logFilePattern, maxLogFiles);
+      //DeleteFile(oldLogFile);
+
+      //// move the other older log files up one slot
+      //for (int i = maxLogFiles - 1; i > 0; i--)
+      //{
+      //    oldLogFile = string.Format(logFilePattern, i);
+      //    newLogFile = string.Format(logFilePattern, i + 1);
+      //    MoveFile(oldLogFile, newLogFile);
+      //}
+
+      //// move the most recent log file up into the backup slots
+      //newLogFile = string.Format(logFilePattern, 1);
+      //MoveFile(logFilename, newLogFile);
+
+      #endregion
+
+      #region Latency Rollover
+
+      #endregion
+
+      // write latency header
+      //if (!File.Exists(latencyFilename))
+      //    CreateLatencyHeader();
+
       // listen to webclient events from the TraktAPI so we can provide useful logging            
-      TraktAPI.OnDataSend += TraktAPI_OnDataSend;
-      TraktAPI.OnDataError += TraktAPI_OnDataError;
-      TraktAPI.OnDataReceived += TraktAPI_OnDataReceived;
+      TraktAPI.OnDataSend += new TraktAPI.OnDataSendDelegate(TraktAPI_OnDataSend);
+      TraktAPI.OnDataError += new TraktAPI.OnDataErrorDelegate(TraktAPI_OnDataError);
+      TraktAPI.OnDataReceived += new TraktAPI.OnDataReceivedDelegate(TraktAPI_OnDataReceived);
+      TraktAPI.OnLatency += new TraktAPI.OnLatencyDelegate(TraktAPI_OnLatency);
     }
 
     internal static void Info(String log)
     {
+      // log to configuration window
+      if (TraktSettings.IsConfiguration == true)
+        OnLogReceived(log, false);
+
       if (TraktSettings.LogLevel >= 2)
-        ServiceRegistration.Get<ILogger>().Info(log);
+        WriteToFile(String.Format(CreatePrefix(), "INFO", log));
     }
 
     internal static void Info(String format, params Object[] args)
@@ -29,7 +84,7 @@ namespace MediaPortal.Extensions.OnlineLibraries.Libraries.Trakt
     internal static void Debug(String log)
     {
       if (TraktSettings.LogLevel >= 3)
-        ServiceRegistration.Get<ILogger>().Debug(log);
+        WriteToFile(String.Format(CreatePrefix(), "DEBG", log));
     }
 
     internal static void Debug(String format, params Object[] args)
@@ -39,8 +94,12 @@ namespace MediaPortal.Extensions.OnlineLibraries.Libraries.Trakt
 
     internal static void Error(String log)
     {
+      // log to configuration window
+      if (TraktSettings.IsConfiguration == true)
+        OnLogReceived(log, true);
+
       if (TraktSettings.LogLevel >= 0)
-        ServiceRegistration.Get<ILogger>().Error(log);
+        WriteToFile(String.Format(CreatePrefix(), "ERR ", log));
     }
 
     internal static void Error(String format, params Object[] args)
@@ -51,7 +110,7 @@ namespace MediaPortal.Extensions.OnlineLibraries.Libraries.Trakt
     internal static void Warning(String log)
     {
       if (TraktSettings.LogLevel >= 1)
-        ServiceRegistration.Get<ILogger>().Warn(log);
+        WriteToFile(String.Format(CreatePrefix(), "WARN", log));
     }
 
     internal static void Warning(String format, params Object[] args)
@@ -59,6 +118,78 @@ namespace MediaPortal.Extensions.OnlineLibraries.Libraries.Trakt
       Warning(String.Format(format, args));
     }
 
+    private static String CreatePrefix()
+    {
+      return DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss.fff") + " [{0}] " + String.Format("[{0}][{1}]", Thread.CurrentThread.Name, Thread.CurrentThread.ManagedThreadId.ToString().PadLeft(2, '0')) + ": {1}";
+    }
+
+    private static void CreateLatencyHeader()
+    {
+      string header = "TimeStamp (UTC),Absolute Path,Query,Method,Status Code,Status Description,Data Sent (Bytes),Data Received (Bytes),Server Execution Time (ms),Total Time Taken (ms)";
+      WriteLatency(header);
+    }
+
+    private static void DeleteFile(String log)
+    {
+      if (File.Exists(log))
+      {
+        try
+        {
+          File.Delete(log);
+        }
+        catch
+        {
+        }
+      }
+    }
+
+    private static void MoveFile(String oldlog, String newLog)
+    {
+      if (File.Exists(oldlog))
+      {
+        // Move to next backup slot
+        try
+        {
+          File.Move(oldlog, newLog);
+        }
+        catch
+        {
+        }
+      }
+    }
+
+    private static void WriteToFile(String log)
+    {
+      try
+      {
+        lock (lockObject)
+        {
+          //StreamWriter sw = File.AppendText(logFilename);
+          //sw.WriteLine(log);
+          //sw.Close();
+        }
+      }
+      catch
+      {
+      }
+    }
+
+    private static void WriteLatency(String latency)
+    {
+      try
+      {
+        //lock (lockObject)
+        //{
+        //    StreamWriter sw = File.AppendText(latencyFilename);
+        //    sw.WriteLine(latency);
+        //    sw.Close();
+        //}
+      }
+      catch
+      {
+      }
+    }
+
     private static void TraktAPI_OnDataSend(string address, string data)
     {
       if (!string.IsNullOrEmpty(data))
@@ -71,14 +202,45 @@ namespace MediaPortal.Extensions.OnlineLibraries.Libraries.Trakt
       }
     }
 
-    private static void TraktAPI_OnDataReceived(string response)
+    private static void TraktAPI_OnDataReceived(string response, HttpWebResponse webResponse)
     {
-      Debug("Response: {0}", response ?? "null");
+      if (TraktSettings.LogLevel >= 3)
+      {
+        string headers = string.Empty;
+        foreach (string key in webResponse.Headers.AllKeys)
+        {
+          headers += string.Format("{0}: {1}, ", key, webResponse.Headers[key]);
+        }
+
+        Debug("Response: {0}, Headers: {{{1}}}", response ?? "null", headers.TrimEnd(new char[] { ',', ' ' }));
+      }
     }
 
     private static void TraktAPI_OnDataError(string error)
     {
-      Error("WebException: {0}", error);
+      Error(error);
+    }
+
+    private static void TraktAPI_OnLatency(double totalTimeTaken, HttpWebResponse webResponse, int dataSent, int dataReceived)
+    {
+      double serverRuntime = 0.0;
+      string[] headers = webResponse.Headers.AllKeys;
+      if (headers.Contains("X-Runtime"))
+      {
+        double.TryParse(webResponse.Headers["X-Runtime"], out serverRuntime);
+
+        // convert to milliseconds from seconds
+        serverRuntime *= 1000.0;
+      }
+
+      // escape query string as it contains comma's
+      string query = webResponse.ResponseUri.Query;
+      if (!string.IsNullOrEmpty(query) && query.Contains(','))
+      {
+        query = "\"" + query + "\"";
+      }
+
+      //WriteLatency(string.Format("{0},{1},{2},{3},{4},{5},{6},{7},{8},{9}", DateTime.UtcNow.ToISO8601(), webResponse.ResponseUri.AbsolutePath, query, webResponse.Method, (int)webResponse.StatusCode, webResponse.StatusDescription, dataSent, dataReceived, serverRuntime, totalTimeTaken));
     }
 
     /// <summary>
@@ -86,49 +248,44 @@ namespace MediaPortal.Extensions.OnlineLibraries.Libraries.Trakt
     /// </summary>
     /// <typeparam name="T">Response Type of message</typeparam>
     /// <param name="response">The response object holding the message to log</param>
-    internal static bool LogTraktResponse<T>(T response)
+    public static bool LogTraktResponse<T>(T response)
     {
-      try
+      if (response == null)
       {
-        TraktResponse traktResponse = (response as TraktResponse);
-        if (traktResponse == null || traktResponse.Status == null)
-        {
-          // server is probably temporarily unavailable
-          // return true even though it failed, so we can try again
-          // currently the return value is only being used in livetv/recordings
-          Error("Response from server was unexpected.");
-          return true;
-        }
-
-        // check response error status
-        if (traktResponse.Status != "success")
-        {
-          Error(traktResponse.Error == "The remote server returned an error: (401) Unauthorized." ? "401 Unauthorized, Please check your Username and Password" : traktResponse.Error);
-          return false;
-        }
+        // we already log errors which would normally not be able to be deserialised
+        // currently the return value is only being used in livetv/recordings
+        return true;
+      }
 
-        // success
-        if (!string.IsNullOrEmpty(traktResponse.Message))
-        {
-          Info("Response: {0}", traktResponse.Message);
-        }
-        else
+      try
+      {
+        // only log the response if we don't have debug logging enabled
+        // we already log all responses in debug level
+        if (TraktSettings.LogLevel < 3)
         {
-          // no message returned on movie sync success
-          TraktSyncResponse traktSyncResponse = (response as TraktSyncResponse);
-          if (traktSyncResponse != null)
+          if ((response is TraktSyncResponse))
           {
-            string message = "Response: Items Inserted: {0}, Items Already Exist: {1}, Items Skipped: {2}";
-            Info(message, traktSyncResponse.Inserted, traktSyncResponse.AlreadyExist, traktSyncResponse.Skipped);
+            Info("Sync Response: {0}", (response as TraktSyncResponse).ToJSON());
+          }
+          else if ((response is TraktScrobbleResponse))
+          {
+            // status code will be greater than 0 if we caught an error
+            // we already log errors so we can supress the scrobble log result
+            var scrobbleResponse = response as TraktScrobbleResponse;
+            if (scrobbleResponse != null && scrobbleResponse.Code == 0)
+            {
+              Info("Scrobble Response: {0}", scrobbleResponse.ToJSON());
+            }
           }
         }
+
         return true;
       }
       catch (Exception)
       {
-        Info("Response: {0}", "Failed to interpret response from server");
+        Info("Response: Failed to interpret response from server");
         return false;
       }
     }
   }
-}
+}
\ No newline at end of file
diff --git a/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/TraktSettings.cs b/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/TraktSettings.cs
index 4678941..2f94289 100644
--- a/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/TraktSettings.cs
+++ b/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/TraktSettings.cs
@@ -1,19 +1,21 @@
 ﻿using System;
 using System.Collections.Generic;
+using System.IO;
 using System.Reflection;
-using System.Threading;
 using MediaPortal.Extensions.OnlineLibraries.Libraries.Trakt.DataStructures;
+using MediaPortal.Extensions.OnlineLibraries.Libraries.Trakt.Enums;
 
 namespace MediaPortal.Extensions.OnlineLibraries.Libraries.Trakt
 {
   public class TraktSettings
   {
-    private readonly Object _lockObject = new object();
+    private static Object lockObject = new object();
 
     #region Settings
-    int SettingsVersion = 1;
 
-    public List<TraktAuthentication> UserLogins { get; set; }
+    private int SettingsVersion = 1;
+
+    public static List<TraktAuthentication> UserLogins { get; set; }
     public bool KeepTraktLibraryClean { get; set; }
     public List<String> BlockedFilenames { get; set; }
     public List<String> BlockedFolders { get; set; }
@@ -32,6 +34,11 @@ namespace MediaPortal.Extensions.OnlineLibraries.Libraries.Trakt
     public int WatchListShowsDefaultLayout { get; set; }
     public int WatchListEpisodesDefaultLayout { get; set; }
     public int ListsDefaultLayout { get; set; }
+    public static TraktLastSyncActivities LastSyncActivities { get; set; }
+    public static IEnumerable<TraktCache.ListActivity> LastListActivities { get; set; }
+    public static bool SkipMoviesWithNoIdsOnSync { get; set; }
+    public static int SyncBatchSize { get; set; }
+    public static int SyncPlaybackCacheExpiry { get; set; }
     public int ListItemsDefaultLayout { get; set; }
     public int RelatedMoviesDefaultLayout { get; set; }
     public int RelatedShowsDefaultLayout { get; set; }
@@ -44,7 +51,7 @@ namespace MediaPortal.Extensions.OnlineLibraries.Libraries.Trakt
     public int DefaultCalendarStartDate { get; set; }
     public bool DownloadFullSizeFanart { get; set; }
     public bool DownloadFanart { get; set; }
-    public int WebRequestCacheMinutes { get; set; }
+    public static int WebRequestCacheMinutes { get; set; }
     public bool GetFollowerRequestsOnStartup { get; set; }
     public int MovingPicturesCategoryId { get; set; }
     public bool MovingPicturesCategories { get; set; }
@@ -112,6 +119,7 @@ namespace MediaPortal.Extensions.OnlineLibraries.Libraries.Trakt
     public bool FilterTrendingOnDashboard { get; set; }
     public bool UseTrailersPlugin { get; set; }
     public bool IgnoreWatchedPercentOnDVD { get; set; }
+
     #endregion
 
     #region Constants
@@ -127,10 +135,7 @@ namespace MediaPortal.Extensions.OnlineLibraries.Libraries.Trakt
 
     public static string Username
     {
-      get
-      {
-        return _username;
-      }
+      get { return _username; }
       set
       {
         _username = value;
@@ -138,14 +143,11 @@ namespace MediaPortal.Extensions.OnlineLibraries.Libraries.Trakt
       }
     }
 
-    static string _username = null;
+    private static string _username = null;
 
     public static string Password
     {
-      get
-      {
-        return _password;
-      }
+      get { return _password; }
       set
       {
         _password = value;
@@ -153,60 +155,56 @@ namespace MediaPortal.Extensions.OnlineLibraries.Libraries.Trakt
       }
     }
 
-    static string _password = null;
+    private static string _password = null;
 
     /// <summary>
     /// Show Advanced or Simple Ratings Dialog
     /// Settings is Synced from Server
     /// </summary>
-    public bool ShowAdvancedRatingsDialog
-    {
-      get
-      {
-        return _showAdvancedRatingsDialogs;
-      }
-      set
-      {
-        // allow last saved setting to be available immediately
-        _showAdvancedRatingsDialogs = value;
-
-        // sync setting - delay on startup
-        Thread syncSetting = new Thread(o =>
-        {
-          if (string.IsNullOrEmpty(Username) || string.IsNullOrEmpty(Password))
-            return;
-
-          Thread.Sleep(5000);
-          TraktLogger.Info("Loading Online Settings");
-
-          TraktAccountSettings settings = TraktAPI.GetAccountSettings();
-          if (settings != null && settings.Status == "success")
-          {
-            _showAdvancedRatingsDialogs = settings.ViewingSettings.RatingSettings.Mode == "advanced";
-          }
-          else
-          {
-            TraktLogger.Error("Failed to retrieve trakt settings online.");
-          }
-        })
-        {
-          IsBackground = true,
-          Name = "Settings"
-        };
-        syncSetting.Start();
-      }
-    }
-    bool _showAdvancedRatingsDialogs;
-
+    //public bool ShowAdvancedRatingsDialog
+    //{
+    //  get
+    //  {
+    //    return _showAdvancedRatingsDialogs;
+    //  }
+    //  set
+    //  {
+    //    // allow last saved setting to be available immediately
+    //    _showAdvancedRatingsDialogs = value;
+
+    //    // sync setting - delay on startup
+    //    Thread syncSetting = new Thread(o =>
+    //    {
+    //      if (string.IsNullOrEmpty(Username) || string.IsNullOrEmpty(Password))
+    //        return;
+
+    //      Thread.Sleep(5000);
+    //      TraktLogger.Info("Loading Online Settings");
+
+    //      TraktAccountSettings settings = TraktAPI.GetAccountSettings();
+    //      if (settings != null && settings.Status == "success")
+    //      {
+    //        _showAdvancedRatingsDialogs = settings.ViewingSettings.RatingSettings.Mode == "advanced";
+    //      }
+    //      else
+    //      {
+    //        TraktLogger.Error("Failed to retrieve trakt settings online.");
+    //      }
+    //    })
+    //    {
+    //      IsBackground = true,
+    //      Name = "Settings"
+    //    };
+    //    syncSetting.Start();
+    //  }
+    //}
+    //bool _showAdvancedRatingsDialogs;
     /// <summary>
     /// Version of Plugin
     /// </summary>
     public static string Version
     {
-      get
-      {
-        return Assembly.GetCallingAssembly().GetName().Version.ToString();
-      }
+      get { return Assembly.GetCallingAssembly().GetName().Version.ToString(); }
     }
 
     /// <summary>
@@ -214,46 +212,39 @@ namespace MediaPortal.Extensions.OnlineLibraries.Libraries.Trakt
     /// </summary>
     public string UserAgent
     {
-      get
-      {
-        return string.Format("TraktForMediaPortal/{0}", Version);
-      }
+      get { return string.Format("TraktForMediaPortal/{0}", Version); }
     }
 
     /// <summary>
     /// The current connection status to trakt.tv
     /// </summary>
-    public ConnectionState AccountStatus
+    public static ConnectionState AccountStatus
     {
       get
       {
-        lock (_lockObject)
+        lock (lockObject)
         {
-          if (_accountStatus == ConnectionState.Pending)
+          if (_AccountStatus == ConnectionState.Pending)
           {
             // update state, to inform we are connecting now
-            _accountStatus = ConnectionState.Connecting;
+            _AccountStatus = ConnectionState.Connecting;
 
-            TraktLogger.Info("Signing into trakt.tv");
+            TraktLogger.Info("Logging into trakt.tv");
 
-            if (string.IsNullOrEmpty(TraktSettings.Username) || string.IsNullOrEmpty(TraktSettings.Password))
+            if (string.IsNullOrEmpty(Username) || string.IsNullOrEmpty(Password))
             {
-              TraktLogger.Info("Username and/or Password is empty in settings!");
+              TraktLogger.Info("Unable to login to trakt.tv, username and/or password is empty");
               return ConnectionState.Disconnected;
             }
 
-            // test connection
-            TraktAccount account = new TraktAccount
+            var response = TraktAPI.Login();
+            if (response != null && !string.IsNullOrEmpty(response.Token))
             {
-              Username = Username,
-              Password = Password
-            };
+              // set the user token for all future requests
+              TraktAPI.UserToken = response.Token;
 
-            TraktResponse response = TraktAPI.TestAccount(account);
-            if (response != null && response.Status == "success")
-            {
-              TraktLogger.Info("User {0} signed into trakt.", Username);
-              _accountStatus = ConnectionState.Connected;
+              TraktLogger.Info("User {0} successfully signed into trakt.tv", Username);
+              _AccountStatus = ConnectionState.Connected;
 
               if (!UserLogins.Exists(u => u.Username == Username))
               {
@@ -262,26 +253,99 @@ namespace MediaPortal.Extensions.OnlineLibraries.Libraries.Trakt
             }
             else
             {
-              TraktLogger.Info("Username and/or Password is Invalid!");
-              _accountStatus = ConnectionState.Invalid;
+              // check the error code for the type of error retured
+              if (response != null && response.Description != null)
+              {
+                TraktLogger.Error("Login to trakt.tv failed, Code = '{0}', Reason = '{1}'", response.Code, response.Description);
+
+                switch (response.Code)
+                {
+                  case 401:
+                    _AccountStatus = ConnectionState.UnAuthorised;
+                    break;
+
+                  default:
+                    _AccountStatus = ConnectionState.Invalid;
+                    break;
+                }
+              }
+              else
+              {
+                // very unlikely to ever hit this condition since we should get some sort of protocol error
+                // if a problem with login or server error
+                _AccountStatus = ConnectionState.Invalid;
+              }
             }
           }
         }
-        return _accountStatus;
+        return _AccountStatus;
       }
       set
       {
-        lock (_lockObject)
+        lock (lockObject)
         {
-          _accountStatus = value;
+          _AccountStatus = value;
+        }
+      }
+    }
+
+    public static ConnectionState _AccountStatus = ConnectionState.Pending;
+
+    /// <summary>
+    /// Build Date of Plugin
+    /// </summary>
+    public static string BuildDate
+    {
+      get
+      {
+        if (_BuildDate == null)
+        {
+          const int PeHeaderOffset = 60;
+          const int LinkerTimestampOffset = 8;
+
+          byte[] buffer = new byte[2047];
+          using (Stream stream = new FileStream(Assembly.GetAssembly(typeof(TraktSettings)).Location, FileMode.Open, FileAccess.Read))
+          {
+            stream.Read(buffer, 0, 2047);
+          }
+
+          int secondsSince1970 = BitConverter.ToInt32(buffer, BitConverter.ToInt32(buffer, PeHeaderOffset) + LinkerTimestampOffset);
+
+          _BuildDate = new DateTime(1970, 1, 1, 0, 0, 0).AddSeconds(secondsSince1970).ToString("yyyy-MM-dd");
         }
+        return _BuildDate;
       }
     }
-    ConnectionState _accountStatus = ConnectionState.Pending;
+
+    private static string _BuildDate;
 
     #endregion
 
+    public static bool? IsConfiguration
+    {
+      get
+      {
+        if (_isConfiguration == null)
+        {
+          try
+          {
+            var entryAssembly = Assembly.GetEntryAssembly();
+
+            _isConfiguration = !Path.GetFileNameWithoutExtension(entryAssembly.Location).Equals("mediaportal", StringComparison.InvariantCultureIgnoreCase);
+          }
+          catch
+          {
+            _isConfiguration = false;
+          }
+        }
+        return _isConfiguration;
+      }
+    }
+
+    private static bool? _isConfiguration;
+
     #region Methods
+
     /// <summary>
     /// Loads the Settings
     /// </summary>
